   //jQuery when DOM loads run this

   function writeMessage(messageLayer, message){
            var context = messageLayer.getContext();
            messageLayer.clear();
            context.font = "18pt Calibri";
            context.fillStyle = "black";
            context.fillText(message, 10, 25);

        }

$(function(){

  //Backbone Model

  window.Star = Backbone.Model.extend({
      // define the function that will be used to get the url, we can change this to anything as long
      // as Rails has a route for it.
    url: function() {
      return this.id ? '/stars/' + this.id : '/stars'; //Ternary, look it up if you aren't sure
    },

    // defaults: { star: {
    //   name: "None entered",
    //   age: 0
    //   breed:
    // }},

    initialize: function(){
      //Can be used to initialize Model attributes
    }
  });

  //Collection

  window.StarCollection = Backbone.Collection.extend({
    model: Star,
    url: '/stars'
  });

  window.Stars = new StarCollection;

  //View

  window.StarView = Backbone.View.extend({
    tagName: "tr",                  // tag to surround  our rendering

    events: {
      //Can be used for handling events on the template
    },

    initialize: function(){
      //this.render();
    },

    render: function( ){
      var star = this.model.toJSON();
     //    alert("Rendering Star");
      //Template stuff goes here
      $(this.el).html(ich.star_template(star));
      //  $(this.el).html(ich.constructor)
      return this;
    },

     renderStar:  function(x,y){
         if (x =='undefined' || y == 'undefined') return;
         if (x < 0 || y < 0) return;

       //  alert ("renderStar "+x+" "+y);

     var star = new Kinetic.Star({
                x: x,
                y: y,
                points: 5,
                innerRadius: 5,
                outerRadius: 10,
                fill: "yellow",
                stroke: "black",
                strokeWidth: 4
            });

            // add the shape to the layer
   //        var canvas = document.getElementById("container");
   //       var context = canvas.getContext("2d");
            window.layer.add(star);
window.layer.draw()
    }
  });

  //AppliStarion View

  window.AppView = Backbone.View.extend({

    el: $("#stars_app"),

    events: {
      "submit form#new_star": "createStar"
    },

    initialize: function(){
      _.bindAll(this, 'addOne', 'addAll');

      Stars.bind('add', this.addOne);
      Stars.bind('refresh', this.addAll);
      Stars.bind('all', this.render);


      Stars.fetch({success: function(mod, response) {
       // alert("Thats cool: " + JSON.stringify(mod));
      }}); //This Gets the Model from the Server
    },

    addOne: function(star) {
      var view = new StarView({model: star});
        //  alert(star.toString());
      this.$("#star_table").append(view.render().el);
        {
             var stars = view.model.toJSON();
            //alert("Add one "+ stars.x_pos);
            view.renderStar(stars.x_pos, stars.y_pos);
        }
         writeMessage(window.messageLayer, "This is Canvas");
    },

    addAll: function(){

      Stars.each(this.addOne);
    },

    //takes form which is arg (currentTarget) of event and converts to a JSON style string
    newAttributes: function(event) {
      //use jquery to get the current target, then convert to serialized 'string'
      var new_star_form = $(event.currentTarget).serializeObject();
        // alert here is great to see the contents of the form
      //alert (JSON.stringify(new_star_form));
       //   alert("newAttributes");
      // create a json style model that can then be passed up the wire
      return { star: {
          x_pos: new_star_form["star[x_pos]"],
          y_pos: new_star_form["star[y_pos]"]

        }}
    },

    createStar: function(e) {
      e.preventDefault(); //This prevents the form from submitting normally

      var params = this.newAttributes(e);
      // create is Backbone method for doing a 'POST' up the wire to Rails (create())
      Stars.create(params);
      this.addAll
      //TODO - Clear the form fields after submitting
    },
      clickCreate: function(x,y){
      //    alert(clickCreate);
        Stars.create(
                 { star: {
          x_pos: x,
          y_pos: y
        }} );
           this.addAll
         // view.renderStar(stars.x_pos, stars.y_pos);
         //  this.renderStar(x,y);
    }
  });

   window.onload = function(){
  //   function createCanvas(){
         //alert (" onload ");
             var stage = new Kinetic.Stage({
                container: "container",
                width: 578,
                height: 500
            });
            var layer = new Kinetic.Layer();
            var clickLayer = new Kinetic.Layer();
            var messageLayer = new Kinetic.Layer();
             window.layer = layer;
              window.messageLayer = messageLayer;
              var x = 100;
        var y = 100;
        var scale = 200;

        //  alert (" onload ");

            writeMessage(messageLayer, "This is Canvas");

                       var rect = new Kinetic.Rect({
                x: 0,
                y: 0,
                width: 500,
                height: 500,
                alpha: 0,
                fill: "#000000",
                stroke: "black",
                strokeWidth: 4
            });

             rect.on("mouseup", function(){
                var mousePos = stage.getMousePosition();
                var x = mousePos.x ;
                var y = mousePos.y ;

                 window.App.clickCreate(x,y);


                writeMessage(messageLayer, "x: " + x + ", y: " + y + 'test');
            });

           clickLayer.add(rect);


             var rect = new Kinetic.Rect({
                x: 0,
                y: 0,
                width: 500,
                height: 500,
                alpha: 1,
                fill: "#000000",
                stroke: "black",
                strokeWidth: 4
            });

            layer.add(rect);
            stage.add(layer);
            stage.add(clickLayer);
            // add the layer to the stage
            stage.add(messageLayer);
        clickLayer.draw();
        layer.draw();
        } ;
  //START THE BACKBONE APP
  //   createCanvas();
  window.App = new AppView;

});




